# -*- coding: utf-8 -*-
import sys
reload(sys)
sys.setdefaultencoding('utf8')
import os
import time
import oss2
from resource import parse_pji_image
import logging 
from utils import json_utils
from utils import yaml_utils
# --------------------------------------------------

def get_paths(local_parse_dir,parse_prefix):
    local_mp4_dir1 = local_parse_dir + '/camera1/'
    mp4_file_name1 = 'camera1'
    local_mp4_file_path1 = local_mp4_dir1 + mp4_file_name1 + '.mp4'
    oss_csv_object_key1 = parse_prefix + 'camera.mp4'


    local_mp4_dir2 = local_parse_dir + '/camera2/'
    mp4_file_name2 = 'camera2'
    local_mp4_file_path2 = local_parse_dir + '/camera2/' + mp4_file_name2 + '.mp4'
    oss_csv_object_key2 = parse_prefix + mp4_file_name2 + '.mp4'

    return local_mp4_dir1,local_mp4_file_path1,oss_csv_object_key1, local_mp4_dir2,local_mp4_file_path2, oss_csv_object_key2

def parse_to_mp4(merged_bag_file_path, parse_prefix, local_parse_dir, local_delete_list):
    try:
        local_mp4_dir1,local_mp4_file_path1,oss_csv_object_key1, local_mp4_dir2,local_mp4_file_path2, oss_csv_object_key2 = get_paths(local_parse_dir,parse_prefix)

        parse_pji_image.parse1('/ob_camera_01/color/image_raw', merged_bag_file_path,local_mp4_dir1)
        bucket.put_object_from_file(oss_csv_object_key1, local_mp4_file_path1)
        logging.info("上传 camera1.mp4 成功: %s" , str(oss_csv_object_key1))

        parse_pji_image.parse2('/ob_camera_02/color/image_raw', merged_bag_file_path,local_mp4_dir2)
        bucket.put_object_from_file(oss_csv_object_key2, local_mp4_file_path2)
        logging.info("上传 camera2.mp4 成功: %s" , str(oss_csv_object_key1))

        local_delete_list.append(local_mp4_file_path1)
        local_delete_list.append(local_mp4_file_path2)
    except Exception as e2:
        logging.exception("生成摄像头视频报错（注意：有可能有的引导机器人只有一个摄像头，但是处理程序是按照两个摄像头生成的，所以此处报错大概率不是程序错误。），添加到 camera-errorBag.json: %s", e2)
        json_utils.add_error(parse_prefix,error_bag_json)


# ------- 获取合并之后的bag包，解析出csv -------
if __name__ == '__main__':
    # --------------------------------------------------
    if len(sys.argv) != 2:
        print("Usage: python script.py <config_file_path>")
        sys.exit(1)
    config_file_path = sys.argv[1]
    try:
        config = yaml_utils.parse_yaml(config_file_path)
    except Exception as e:
        print("Error parsing YAML file:", e)
        sys.exit(1)
    # --------------------------------------------------
    auth = oss2.Auth(config['oss']['access-key-id'], config['oss']['access-key-secret']) # oss 账号密码
    endpoint = config['oss']['endpoint'] # oss 地址
    bucket_name = config['oss']['bucket-name'] # oss 桶
    oss_data_root = config['oss']['data-root'] # 数据所在的oss根目录
    log_file_path = config['log-file-path'] # 日志文件地址
    temp_dir = config['temp-dir']
    error_bag_json = config['error-bag-json']
    sleep_time = config['sleep-time']  # 每多少秒扫描一次
    # --------------------------------------------------
    logging.basicConfig(filename=log_file_path, level=logging.INFO,format='%(asctime)s - %(levelname)s - %(message)s')
    bucket = oss2.Bucket(auth, endpoint, bucket_name)
    # --------------------------------------------------
    logging.info("Access Key ID:%s", config['oss']['access-key-id'])
    logging.info("Access Key Secret:%s", config['oss']['access-key-secret'])
    logging.info("Endpoint:%s", config['oss']['endpoint'])
    logging.info("Bucket Name:%s", config['oss']['bucket-name'])
    logging.info("OSS Data Root:%s", config['oss']['data-root'])
    logging.info("Log File Path:%s", config['log-file-path'])
    logging.info("临时文件目录:%s", config['temp-dir'])
    logging.info("错误目录json路径:%s", config['error-bag-json'])
    logging.info("Sleep Time:%s", config['sleep-time'])
    # --------------------------------------------------
    while True:
        logging.info("开始新一轮扫描")
        try:
            local_delete_list = []
            oss_delete_list = []
            prefix_list = []
            # 2 获取已经上传完成的所有目录并分组
            for obj1 in oss2.ObjectIterator(bucket, prefix=oss_data_root):
                # 获取合并后的包
                merged_bag_object_key = str(obj1.key)
                if 'data_merge' in str(obj1.key) and str(obj1.key).endswith('.bag'):
                    merged_bag_object_key_split = merged_bag_object_key.split('/')
                    merged_prefix = '/'.join(merged_bag_object_key_split[:-1])
                    parse_prefix = merged_prefix.replace('data_merge', 'data_parse')
                    parse_prefix_full = merged_bag_object_key.replace('data_merge', 'data_parse')[:-4] + '/'
                    camera_done = False
                    camera2_done = False
                    for obj2 in oss2.ObjectIterator(bucket, prefix=parse_prefix_full):
                        if '/camera.mp4' in str(obj2.key):
                            camera_done = True
                        if '/camera2.mp4' in str(obj2.key):
                            camera2_done = True
                    if camera_done and camera2_done:
                        continue
                    error_bag_list = json_utils.parse_json_to_string_array(error_bag_json)
                    if parse_prefix_full in error_bag_list:
                        continue
                    logging.info("%s 等待处理到： %s", merged_bag_object_key, parse_prefix_full)
                    local_merged_bag_path = temp_dir + 'camera/' + merged_bag_object_key
                    local_merged_dir = '/'.join(local_merged_bag_path.split('/')[:-1])
                    local_parse_dir = local_merged_dir.replace('data_merge', 'data_parse')
                    if not os.path.exists(local_merged_dir):
                        os.makedirs(local_merged_dir)
                    if not os.path.exists(local_parse_dir):
                        os.makedirs(local_parse_dir)
                    merged_bag_full_name = merged_bag_object_key_split[-1]
                    merged_bag_name = merged_bag_full_name.split('.')[0]
                    try:
                        bucket.get_object_to_file(merged_bag_object_key, local_merged_bag_path)
                    except Exception as e:
                        logging.exception("下载合并后的bag包失败: %s" % str(e))

                    local_delete_list.append(local_merged_bag_path)
                    # 2 生成 pos_orig.csv 和 pos_hmi.csv
                    parse_to_mp4(local_merged_bag_path, parse_prefix_full, local_parse_dir, local_delete_list)

            # 删除本地临时文件
            if len(local_delete_list) > 0:
                for local_delete in local_delete_list:
                    try:
                        os.remove(local_delete)
                    except Exception as e:
                        pass
            time.sleep(sleep_time)
        except Exception as e:
            logging.exception("全局错误处理: %s" % str(e))
