# -*- coding: utf-8 -*-
import sys
reload(sys)
sys.setdefaultencoding("utf-8")
import os
import time
import oss2 
import logging
from utils import json_utils
from utils import yaml_utils
# --------------------------------------------------

def parse_to_pcd_mp4(merged_bag_file_path, parse_prefix2, local_parse_dir, local_delete_list):
    global bucket
    try:
        os.chdir(run_sh_dir)
        command1 = 'sh run.sh ' + merged_bag_file_path + ' ' + local_parse_dir
        logging.info("调用命令lidar视频生成命令: %s" % str(command1))
        os.system(command1)

        file_name_with_extension = os.path.basename(merged_bag_file_path)
        file_name_without_extension = os.path.splitext(file_name_with_extension)[0]
        parent_directory = os.path.dirname(merged_bag_file_path)
        local_pcd_mp4_dir3 = parent_directory.replace('data_merge','data_parse') + '/' + file_name_without_extension + '_pcd_lidar'
        pcd_mp4_file_name3 = 'pcd_lidar'
        local_pcd_mp4_path3 = local_pcd_mp4_dir3 + '/pcd_overlook.mp4'
        oss_csv_object_key3 = parse_prefix2 + pcd_mp4_file_name3 + '.mp4'
        bucket.put_object_from_file(oss_csv_object_key3, local_pcd_mp4_path3)
        logging.info("上传点云视频到: %s", oss_csv_object_key3)
        # ------- end -------
        local_delete_list.append(local_pcd_mp4_path3)
    except Exception as e:
        error_bag_list = json_utils.parse_json_to_string_array(error_bag_json)
        error_bag_list.append(parse_prefix2)
        json_utils.list_to_json_file(error_bag_list, error_bag_json)
        logging.exception("生成点云视频报错: %s" % str(e))


if __name__ == '__main__':
        # --------------------------------------------------
    if len(sys.argv) != 2:
        print("Usage: python script.py <config_file_path>")
        sys.exit(1)
    config_file_path = sys.argv[1]
    try:
        config = yaml_utils.parse_yaml(config_file_path)
    except Exception as e:
        print("Error parsing YAML file:", e)
        sys.exit(1)
    # --------------------------------------------------
    temp_dir = config['temp-dir'] # 临时文件目录
    run_sh_dir = config['run-sh-dir'] # 临时文件目录
    oss_data_root = config['oss']['data-root'] # 数据所在的oss根目录
    sleep_time = config['sleep-time']  # 每多少秒扫描一次
    error_bag_json = config['error-bag-json'] # 错误目录json
    log_file_path = config['log-file-path'] # 日志文件地址
    auth = oss2.Auth(config['oss']['access-key-id'], config['oss']['access-key-secret']) # oss 账号密码
    endpoint = config['oss']['endpoint'] # oss 地址
    bucket_name = config['oss']['bucket-name'] # oss 桶
    # --------------------------------------------------
    logging.basicConfig(filename=log_file_path, level=logging.INFO,format='%(asctime)s - %(levelname)s - %(message)s')
    bucket = oss2.Bucket(auth, endpoint, bucket_name)
    # --------------------------------------------------
    # 访问解析后的数据
    logging.info("临时文件目录:%s", config['temp-dir'])
    logging.info("Access Key ID:%s", config['oss']['access-key-id'])
    logging.info("Access Key Secret:%s", config['oss']['access-key-secret'])
    logging.info("Endpoint:%s", config['oss']['endpoint'])
    logging.info("Bucket Name:%s", config['oss']['bucket-name'])
    logging.info("OSS 数据根目录:%s", config['oss']['data-root'])
    logging.info("日志文件目录:%s", config['log-file-path'])
    logging.info("错误目录json路径:%s", config['error-bag-json'])
    logging.info("每一轮休眠时间:%s", config['sleep-time'])
    # -------------------------------------------------- 
    while True:
        logging.info("开始新一轮扫描")
        try:
            local_delete_list = []
            oss_delete_list = []
            prefix_list = []
            # 2 获取已经上传完成的所有目录并分组
            for obj1 in oss2.ObjectIterator(bucket, prefix=oss_data_root):
                try:
                    # 获取合并后的包
                    merged_bag_object_key = str(obj1.key)
                    # print(f'判断1{merged_bag_object_key}')
                    if 'data_merge' in str(obj1.key) and str(obj1.key).endswith('.bag'):
                        merged_bag_object_key_split = merged_bag_object_key.split('/')
                        merged_prefix = '/'.join(merged_bag_object_key_split[:-1])
                        parse_prefix = merged_prefix.replace('data_merge', 'data_parse')
                        parse_prefix_full = merged_bag_object_key.replace('data_merge', 'data_parse')[:-4] + '/'
                        # pcd1_done = False
                        # pcd2_done = False
                        pcd3_done = False
                        for obj2 in oss2.ObjectIterator(bucket, prefix=parse_prefix_full):
                            # if '/pcd_depthcamera.mp4' in str(obj2.key):
                            #     pcd1_done = True
                            if '/pcd_lidar.mp4' in str(obj2.key):
                                pcd3_done = True
                        if pcd3_done:
                            # logging.info( "%s 存在点云视频 pcd_depthcamera.mp4 和 pcd_lidar.mp4" % str(parse_prefix_full))
                            # logging.info("%s 存在点云视频 pcd_lidar.mp4 " % str(parse_prefix_full))
                            continue
                        error_bag_list = json_utils.parse_json_to_string_array(error_bag_json)
                        if parse_prefix_full in error_bag_list:
                            continue
                        logging.info("%s 缺少点云视频 pcd_depthcamera.mp4 和 pcd_lidar.mp4" % str(parse_prefix_full))
                        # print(f'需要解析{merged_bag_object_key}')
                        local_merged_bag_path = temp_dir + 'pcd/' + merged_bag_object_key
                        local_merged_dir = '/'.join(local_merged_bag_path.split('/')[:-1])
                        local_parse_dir = local_merged_dir.replace('data_merge', 'data_parse')
                        if not os.path.exists(local_merged_dir):
                            os.makedirs(local_merged_dir)
                        if not os.path.exists(local_parse_dir):
                            os.makedirs(local_parse_dir)
                        merged_bag_full_name = merged_bag_object_key_split[-1]
                        merged_bag_name = merged_bag_full_name.split('.')[0]
                        bucket.get_object_to_file(merged_bag_object_key, local_merged_bag_path)
                        local_delete_list.append(local_merged_bag_path)
                        # 2 生成 pos_orig.csv 和 pos_hmi.csv
                        parse_to_pcd_mp4(local_merged_bag_path, parse_prefix_full, local_parse_dir, local_delete_list)
                except Exception as e:
                    logging.exception("报错: %s" % str(e))
            # 删除本地临时文件
            if len(local_delete_list) > 0:
                for local_delete in local_delete_list:
                    try:
                        os.remove(local_delete)
                    except Exception as e:
                        logging.exception("删除本地临时文件报错: %s" % str(e))
            time.sleep(sleep_time)
        except Exception as e:
            logging.exception("全局异常处理: %s" % str(e))
