# -*- coding: utf-8 -*-
import sys
reload(sys)
sys.setdefaultencoding("utf-8")
import json
import time
import urllib2
import oss2
import logging
from datetime import datetime, timedelta
from utils import yaml_utils
# --------------------------------------------------
def add_hour(date_string, hour_number):
    original_date = datetime.strptime(date_string, "%Y-%m-%d-%H-%M-%S")
    new_date = original_date + timedelta(hours=hour_number)
    return new_date.strftime("%Y-%m-%d-%H-%M-%S")


def judge_report_pdf(callback_json_oss_key):
    pdf = False
    try:
        json_content = bucket.get_object(callback_json_oss_key).read()
        json_object = json.loads(json_content)
        if 'check' not in json_object:
            logging.error("Missing 'check' field in %s", callback_json_oss_key)
            return pdf
        check = json_object['check']
        if '位姿信息缺失' in check or '自车数据缺失' in check:
            pdf = True
    except ValueError as e:
        logging.error("Failed to decode JSON from %s", e)
    except Exception as e:
        logging.error("Error processing %s", e)
    return pdf

def judge_pcd(callback_json_oss_key):
    pcd = False
    try:
        json_content = bucket.get_object(callback_json_oss_key).read()
        json_object = json.loads(json_content)
        if 'check' not in json_object:
            logging.error("Missing 'check' field in %s", callback_json_oss_key)
            return pcd
        check = json_object['check']
        if '点云缺失' in check or '点云丢帧' in check:
            pcd = True
    except ValueError as e:
        logging.error("Failed to decode JSON from %s", e)
    except Exception as e:
        logging.error("Error processing %s", e)
    return pcd


if __name__ == '__main__':
    # --------------------------------------------------
    if len(sys.argv) != 2:
        print("Usage: python script.py <config_file_path>")
        sys.exit(1)
    config_file_path = sys.argv[1]
    try:
        config = yaml_utils.parse_yaml(config_file_path)
    except Exception as e:
        print("Error parsing YAML file:", e)
        sys.exit(1)
    # --------------------------------------------------
    auth = oss2.Auth(config['oss']['access-key-id'], config['oss']['access-key-secret']) # oss 账号密码
    endpoint = config['oss']['endpoint'] # oss 地址
    bucket_name = config['oss']['bucket-name'] # oss 桶
    log_file_path = config['log-file-path'] # 日志文件地址
    oss_data_root = config['oss']['data-root'] # 数据所在的oss根目录
    url1_private = config['platform-url']['auth'] # 获取token的接口
    url2_private = config['platform-url']['callback'] # 回传数据的接口
    sleep_time = config['sleep-time'] # 每一轮休眠时间
    # --------------------------------------------------
    logging.basicConfig(filename=log_file_path, level=logging.INFO,format='%(asctime)s - %(levelname)s - %(message)s')
    bucket = oss2.Bucket(auth, endpoint, bucket_name)
    # --------------------------打印配置项------------------------
    logging.info("Access Key ID:%s", config['oss']['access-key-id'])
    logging.info("Access Key Secret:%s", config['oss']['access-key-secret'])
    logging.info("Endpoint:%s", config['oss']['endpoint'])
    logging.info("Bucket Name:%s", config['oss']['bucket-name'])
    logging.info("OSS Data Root:%s", config['oss']['data-root'])
    logging.info("Log File Path:%s", config['log-file-path'])
    logging.info("Platform URL Auth:%s", config['platform-url']['auth'])
    logging.info("Platform URL Callback:%s", config['platform-url']['callback'])
    logging.info("Sleep Time:%s", config['sleep-time'])
    # --------------------------------------------------
    while True:
        logging.info("开始新一轮扫描")
        try:
            local_delete_list = []
            oss_delete_list = []
            upload_completed_prefix_list = []
            # 4 获取即将被合并的bag目录
            for obj1 in oss2.ObjectIterator(bucket, prefix=oss_data_root):
                try:
                    if 'callback.json' in str(obj1.key):
                        prefix = '/'.join(str(obj1.key).split('/')[:-1])

                        done1 = False
                        done2 = False
                        done3 = False
                        done4 = False
                        done5 = False
                        pdf_ok = False
                        for obj2 in oss2.ObjectIterator(bucket, prefix=prefix):
                            if '/EgoState_pji.csv' in str(obj2.key):
                                done1 = True
                            if '/build_map.bag' in str(obj2.key):
                                done2 = True
                            if '/costmap.bag' in str(obj2.key):
                                done3 = True
                            if '/map.bag' in str(obj2.key):
                                done4 = True
                            if '/tfstatic.bag' in str(obj2.key):
                                done5 = True
                            if '/report.pdf' in str(obj2.key):
                                pdf_ok = True
                            if '/pcd_lidar.mp4' in str(obj2.key):
                                pcd_ok = True
                        if not done1 or not done2 or not done3 or not done4 or not done5:
                            continue
                        if not pdf_ok:
                            pdf_ok = judge_report_pdf(str(obj1.key))
                            if not pdf_ok:
                                continue
                        if not pcd_ok:
                            pcd_ok = judge_pcd(str(obj1.key))
                            if not pcd_ok:
                                continue
                        time.sleep(1)
                        logging.info("发送： %s", str(obj1.key))
                        # 1 获取json内容
                        json_content = bucket.get_object(str(obj1.key)).read()
                        # 2 获取token
                        json_object = json.loads(json_content)
                        data1 = {
                            "equipmentNo": json_object['equipmentNo'],
                            "secretKey": json_object['secretKey']
                        }
                        json_data1 = json.dumps(data1)
                        logging.info("授权接口请求中： %s" % url1_private)
                        logging.info("授权发送参数为： %s" % str(data1))
                        request1 = urllib2.Request(url1_private, json_data1,
                                                   headers={'Content-Type': 'application/json'})
                        response1 = urllib2.urlopen(request1)
                        result_json1 = response1.read()
                        result_object1 = json.loads(result_json1)
                        logging.info("授权接口请求结果为： %s", result_object1)
                        access_token = result_object1.get('data').get('accessToken')
                        # 要发送的JSON参数
                        try:
                            # logging.info("bag文件为： %s", json_object['rosBagPath'])
                            old_date = json_object['dataName']
                            data_size = bucket.get_object_meta(json_object['rosBagPath']).content_length
                            equipment_no = json_object['equipmentNo']
                            old_file_path = json_object['filePath']
                            old_ros_bag_path = json_object['rosBagPath']
                            task_id = json_object['taskId']
                            trigger_id = json_object['triggerId']
                            check = []
                            # 检查 'check' 键的值是列表还是字符串
                            if 'check' in json_object:
                                if isinstance(json_object['check'], list):
                                    # 如果 'check' 是列表，则直接使用它（或者根据需要处理）
                                    check = json_object['check']  # 如果不需要修改列表，可以直接赋值
                                elif isinstance(json_object['check'], basestring):
                                    # 如果 'check' 是字符串，则将其添加到空列表中
                                    check = [json_object['check']]
                                else:
                                    # 如果 'check' 不是列表也不是字符串，记录日志或进行其他错误处理
                                    logging.warning("'check' 的类型不是列表也不是字符串，类型为：%s", type(json_object['check']))
                            else:
                                # 如果 'check' 键不存在，记录日志或进行其他错误处理
                                logging.warning("'check' 键在 json_object 中不存在")
                            check_order = ['点云缺失','点云丢帧','图像缺失', '图像丢帧', '位姿信息缺失', '自车数据缺失','/move_base/global_costmap/costmap话题缺失', '/move_base/local_costmap/costmap话题缺失','merged_obstacles.csv文件缺失', '正常']
                            check_order_dict = dict((item, idx) for idx, item in enumerate(check_order))
                            check = sorted(check, key=lambda x: check_order_dict.get(x, float('inf')))
                            if len(check) > 1:
                                check = [item for item in check if item != "正常"]
                            check = ','.join(check) # 数组元素拼接成字符串序列
                        except Exception as e:
                            logging.exception("callback报错：%s", str(e))
                            continue
                        if old_date is None:
                            old_date = ''
                        # 将时区统一（室外不需要需要加8，根据机器人终端的时区判断）
                        # new_date = add_hour(old_date, 8)
                        new_date = old_date
                        old_delete_list = []
                        for obj_old in oss2.ObjectIterator(bucket, prefix=old_file_path):
                            old_delete_list.append(str(obj_old.key))
                            if 'callback.json' in str(obj_old.key):
                                bucket.copy_object(bucket_name, str(obj_old.key),
                                                   str(obj_old.key).replace(old_date, new_date).replace('callback.json',
                                                                                                        'callback_done.json'))
                                bucket.delete_object(str(obj_old.key))  # 删除 callback.json
                        # todo 时区不变也就不需要移动文件了
                        #     else:
                        #         bucket.copy_object(bucket_name, str(obj_old.key),
                        #                            str(obj_old.key).replace(old_date, new_date))
                        # bucket.copy_object(bucket_name, old_ros_bag_path, old_ros_bag_path.replace(old_date, new_date))
                        # bucket.delete_object(old_ros_bag_path)
                        # bucket.batch_delete_objects(old_delete_list)

                        if 'userId' in json_object:
                            logging.info("json_object 包含 'userId' 字段，值为:", json_object['userId'])
                            data2 = {
                                'userId': json_object['userId'],
                                "dataName": new_date,
                                "dataSize": data_size,
                                "equipmentNo": equipment_no,
                                "filePath": old_file_path.replace(old_date, new_date),
                                "rosBagPath": old_ros_bag_path.replace(old_date, new_date),
                                "taskId": task_id,
                                "triggerId": trigger_id,
                                "check":check
                            }
                        else:
                            logging.info("json_object 不包含 'userId' 字段")
                            data2 = {
                                "dataName": new_date,
                                "dataSize": data_size,
                                "equipmentNo": equipment_no,
                                "filePath": old_file_path.replace(old_date, new_date),
                                "rosBagPath": old_ros_bag_path.replace(old_date, new_date),
                                "taskId": task_id,
                                "triggerId": trigger_id,
                                "check":check
                            }
                        json_data2 = json.dumps(data2)
                        logging.info("回调接口请求中：%s" % url2_private)
                        request2 = urllib2.Request(url2_private, json_data2,
                                                   headers={'Content-Type': 'application/json',
                                                            'authorization': access_token})
                        response2 = urllib2.urlopen(request2)
                        result_json2 = response2.read()
                        result_object2 = json.loads(result_json2)
                        logging.info("回调接口请求结果为： %s", result_object2)
                except Exception as e:
                    logging.exception("局部异常处理: %s" % str(e))
            time.sleep(sleep_time)
        except Exception as e:
            logging.exception("全局错误处理: %s" % str(e))
