# -*- coding: utf-8 -*-
import sys
reload(sys)
sys.setdefaultencoding('utf8') 
import os
import time
import oss2
import json
import subprocess
import logging
import io
from resource import bagtocsv_robot
from utils import json_utils
from utils import yaml_utils
# -------------------------------------------------- 
def parse_csv(costmap_bag, data_bag, parse_prefix, local_parse_dir, local_delete_list):
    try:
        bagtocsv_robot.parse(costmap_bag, data_bag, local_parse_dir + '/csv/')
        bagname = data_bag.split('/')[-1].split('.')[0]
        local_csv_dir = os.path.join(local_parse_dir + '/csv/', bagname)
        
        # ------- 上传 csv - 开始 -------
        csv_file_name1 = 'pos_pji'
        local_csv_file_path1 = str(local_csv_dir) + '/' + str(csv_file_name1) + '.csv'
        oss_csv_object_key1 = parse_prefix + csv_file_name1 + '.csv'
        if os.path.exists(local_csv_file_path1):
            bucket.put_object_from_file(oss_csv_object_key1, local_csv_file_path1)
            local_delete_list.append(local_csv_file_path1)
        else:
            logging.error("没有 pos_pji.csv")
            json_utils.add_error(parse_prefix,error_bag_json)

        csv_file_name2 = 'EgoState_pji'
        local_csv_file_path2 = str(local_csv_dir) + '/' + str(csv_file_name2) + '.csv'
        oss_csv_object_key2 = parse_prefix + csv_file_name2 + '.csv'
        if os.path.exists(local_csv_file_path2):
            bucket.put_object_from_file(oss_csv_object_key2, local_csv_file_path2)
            local_delete_list.append(local_csv_file_path2)
        else:
            logging.error("没有 EgoState_pji.csv")
            json_utils.add_error(parse_prefix,error_bag_json)
        
        csv_file_name3 = 'merged_obstacles'
        local_csv_file_path3 = str(local_csv_dir) + '/' + str(csv_file_name3) + '.csv'
        oss_csv_object_key3 = parse_prefix + csv_file_name3 + '.csv'
        if os.path.exists(local_csv_file_path3):
            bucket.put_object_from_file(oss_csv_object_key3, local_csv_file_path3)
            local_delete_list.append(local_csv_file_path3)
        else:
            logging.error("没有 merged_obstacles.csv")
            json_utils.add_error(parse_prefix,error_bag_json)
        # ------- 上传 csv - 结束 -------
        
        # ------- 解析 csv 解析输出的错误信息添加到check字段 output.json - 开始 -------
        logging.info("解析 csv 解析输出的错误信息添加到check字段 output.json")
        outputs = []
        try:
            # 1 解析 output.json
            output_json_path = str(local_csv_dir)+'/output.json'
            if os.path.exists(output_json_path):
                outputs = json_utils.parse_json_to_string_array(output_json_path)
                # 2 将 output.json 添加到 callback.json 的 check 字段
                callback_json_oss_key = parse_prefix+'callback.json'
                callback_json_local = local_csv_dir+'/callback.json'
                bucket.get_object_to_file(callback_json_oss_key, callback_json_local)
                with io.open(callback_json_local, 'r', encoding='utf-8') as f:
                    data = json.load(f)
                if 'check' not in data:
                    data['check'] = []
                data['check'].extend(outputs)
                data['check'] = list(set(data['check']))
                json_data = json.dumps(data, ensure_ascii=False, indent=4)
                with io.open(callback_json_local, 'w', encoding='utf-8') as f:
                    f.write(unicode(json_data))
                bucket.put_object_from_file(callback_json_oss_key, callback_json_local)
        except Exception as e3:
            # todo 可能没有callback.json，已经处理成 callback_done.json了，暂时不管
            pass
        # ------- 处理 output.json - 结束 -------
        logging.info("output.json 数组内容: [%s]", ', '.join(map(str, outputs)))
        

        # ------- 生成 pdf 报告 - 开始 -------
        if '自车数据缺失' not in outputs and '位姿信息缺失' not in outputs:
            pdf_local_path = os.path.join(local_csv_dir, 'report.pdf')
            track_png_key = parse_prefix + 'track.png'
            track_png_path = os.path.join(local_csv_dir, 'track.png')
            bucket.get_object_to_file(track_png_key, track_png_path)
            os.chdir(pdf_command_dir)
            command1 = [command_report, local_csv_dir,track_png_path, config_json_path]
            logging.info("调用生成pdf 报告命令: %s" % ' '.join(command1))
            try:
                process = subprocess.Popen(command1, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
                stdout, stderr = process.communicate()  # 等待进程完成并获取输出
                exit_code = process.returncode
                if exit_code == 0:
                    logging.info("PDF报告生成成功，输出:\n%s" % stdout.decode('utf-8'))  # Python 2中字符串需要解码
                else:
                    logging.error("PDF报告生成失败，错误:\n%s" % stderr.decode('utf-8'))
                    json_utils.add_error(parse_prefix, error_bag_json)
            except Exception as e:
                logging.error("执行命令时发生异常: %s" % str(e))
                json_utils.add_error(parse_prefix, error_bag_json)
            else:
                # 如果PDF文件存在
                if os.path.exists(pdf_local_path):
                    bucket.put_object_from_file(parse_prefix + 'report.pdf', pdf_local_path)
                    local_delete_list.append(pdf_local_path)
                else:
                    # 如果不存在，记录错误日志
                    logging.error("命令执行成功，但没有找到 report.pdf")
                    json_utils.add_error(parse_prefix, error_bag_json)
        else:
            logging.info("不满足 report.pdf 生成条件，不调用命令。")
        # ------- 生成 pdf 报告 - 结束 -------
        

        # ------- 根据 merged_obstacles 和 机器人指定的pgm文件 生成新的 merged_obstacles 文件 -------
        if '/move_base/global_costmap/costmap话题缺失' not in outputs and '/move_base/local_costmap/costmap话题缺失' not in outputs:
            os.chdir(merged_obstacles_dir)
            command2 = "{} {} {}".format(merged_obstacles_command, merged_obstacles_pgm, local_csv_file_path3)
            logging.info("调用命令 merged_obstacles_new.csv 生成命令: %s", command2)
            process = subprocess.Popen(command2, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            stdout, stderr = process.communicate()  # 获取标准输出和错误输出
            if process.returncode == 0:
                logging.info("命令输出: %s", stdout)
            else:
                logging.error("命令执行失败，错误信息: %s", stderr)
            time.sleep(2)
            bucket.put_object_from_file(oss_csv_object_key3.replace('merged_obstacles', 'merged_obstacles_new'),local_csv_file_path3)  # 因为生成的文件是同名覆盖的
        else:
            logging.info("不满足 merged_obstacles_new.csv 生成条件，不调用命令。")
    except Exception as e2:
        logging.exception("生成csv报错，添加到 errorBag.json: %s", e2)
        json_utils.add_error(parse_prefix,error_bag_json)


if __name__ == '__main__':
    # --------------------------------------------------
    if len(sys.argv) != 2:
        print("Usage: python script.py <config_file_path>")
        sys.exit(1)
    config_file_path = sys.argv[1]
    try:
        config = yaml_utils.parse_yaml(config_file_path)
    except Exception as e:
        print("Error parsing YAML file:", e)
        sys.exit(1)
    # --------------------------------------------------
    auth = oss2.Auth(config['oss']['access-key-id'], config['oss']['access-key-secret']) # oss 账号密码
    endpoint = config['oss']['endpoint'] # oss 地址
    bucket_name = config['oss']['bucket-name'] # oss 桶
    oss_data_root = config['oss']['data-root'] # 数据所在的oss根目录
    log_file_path = config['log-file-path'] # 日志文件地址
    pdf_command_dir = config['pdf']['dir']
    command_report = config['pdf']['command']
    config_json_path = config['pdf']['config']
    merged_obstacles_command = config['merged-obstacles']['command']
    merged_obstacles_dir = config['merged-obstacles']['dir']
    merged_obstacles_pgm = config['merged-obstacles']['pgm']
    temp_dir = config['temp-dir']
    error_bag_json = config['error-bag-json']
    sleep_time = config['sleep-time']  # 每多少秒扫描一次
    # --------------------------------------------------
    logging.basicConfig(filename=log_file_path, level=logging.INFO,format='%(asctime)s - %(levelname)s - %(message)s')
    bucket = oss2.Bucket(auth, endpoint, bucket_name)
    # --------------------------------------------------
    logging.info("Access Key ID:%s", config['oss']['access-key-id'])
    logging.info("Access Key Secret:%s", config['oss']['access-key-secret'])
    logging.info("Endpoint:%s", config['oss']['endpoint'])
    logging.info("Bucket Name:%s", config['oss']['bucket-name'])
    logging.info("OSS Data Root:%s", config['oss']['data-root'])
    logging.info("Log File Path:%s", config['log-file-path'])
    logging.info("PDF命令目录:%s", pdf_command_dir)
    logging.info("PDF命令:%s", command_report)
    logging.info("PDF命令配置文件路径:%s", config_json_path)
    logging.info("merged_obstacles_command:%s", config['merged-obstacles']['command'])
    logging.info("merged_obstacles_dir:%s", config['merged-obstacles']['dir'])
    logging.info("merged_obstacles_pgm:%s", config['merged-obstacles']['pgm'])
    logging.info("临时文件目录:%s", config['temp-dir'])
    logging.info("错误目录json路径:%s", config['error-bag-json'])
    logging.info("Sleep Time:%s", config['sleep-time'])
    # --------------------------------------------------
    while True:
        logging.info("开始新一轮扫描：%s " % oss_data_root)
        time.sleep(sleep_time)
        try:
            local_delete_list = []
            oss_delete_list = []
            prefix_list = []
            # 2 获取已经上传完成的所有目录并分组
            for obj1 in oss2.ObjectIterator(bucket, prefix=oss_data_root):
                # 获取合并后的包
                merged_bag_object_key = str(obj1.key)
                if 'data_merge' in str(obj1.key) and str(obj1.key).endswith('.bag'):
                    merged_bag_object_key_split = merged_bag_object_key.split('/')
                    merged_prefix = '/'.join(merged_bag_object_key_split[:-1])
                    parse_prefix = merged_prefix.replace('data_merge', 'data_parse')
                    parse_prefix_full = merged_bag_object_key.replace('data_merge', 'data_parse')[:-4] + '/'
                    csv1_done = False
                    csv2_done = False
                    csv3_done = False
                    # csv4_done = False
                    pdf_done = False
                    track_done = False
                    for obj2 in oss2.ObjectIterator(bucket, prefix=parse_prefix_full):
                        if '/pos_pji.csv' in str(obj2.key):
                            csv1_done = True
                        if '/EgoState_pji.csv' in str(obj2.key):
                            csv2_done = True
                        if '/merged_obstacles.csv' in str(obj2.key):
                            csv3_done = True
                        # if '/merged_obstacles_new.csv' in str(obj2.key): # todo 可以加上这个判断
                        #     csv4_done = True
                        if '/report.pdf' in str(obj2.key):
                            pdf_done = True
                        if '/track.png' in str(obj2.key):
                            track_done = True
                    if csv1_done and csv2_done and csv3_done and pdf_done and track_done:
                        continue
                    error_bag_list = json_utils.parse_json_to_string_array(error_bag_json)
                    if parse_prefix_full in error_bag_list:
                        continue
                    logging.info("开始解析csv并生成评价报告: %s" % str(obj1.key))
                    local_merged_bag_path = temp_dir + 'csv/' + merged_bag_object_key
                    local_merged_dir = '/'.join(local_merged_bag_path.split('/')[:-1])
                    local_parse_dir = local_merged_dir.replace('data_merge', 'data_parse')
                    if not os.path.exists(local_merged_dir):
                        os.makedirs(local_merged_dir)
                    if not os.path.exists(local_parse_dir):
                        os.makedirs(local_parse_dir)
                    merged_bag_full_name = merged_bag_object_key_split[-1]
                    merged_bag_name = merged_bag_full_name.split('.')[0]
                    bucket.get_object_to_file(merged_bag_object_key, local_merged_bag_path)
                    local_delete_list.append(local_merged_bag_path)
                    # 下载costmap.bag
                    costmap_key = merged_prefix.replace('data_merge', '') + 'costmap.bag'
                    bucket.get_object_to_file(costmap_key, local_merged_dir + 'costmap.bag')
                    # 2 生成 pos_orig.csv 和 pos_hmi.csv
                    parse_csv(local_merged_dir + 'costmap.bag', local_merged_bag_path, parse_prefix_full,local_parse_dir, local_delete_list)

            # 删除本地临时文件
            if len(local_delete_list) > 0:
                for local_delete in local_delete_list:
                    try:
                        os.remove(local_delete)
                    except Exception as e:
                        logging.exception("捕获到一个异常: %s" % str(e))
        except Exception as e:
            logging.exception("全局错误处理: %s" % str(e))
